1 Introduction
Given a set of points representing clients or demands, the center problem asks to determine a collection of center points for placing facilities so as to minimize the maximum distance from any demand to its nearest facility. Geometrically speaking, the goal is to find the centers of equalradius balls whose union covers and whose common radius, the radius of the center, is as small as possible. This paper assumes the discrete version of the center problem where centers are selected from .
The center problem is NPhard when is an arbitrary input parameter and NPhard to approximate within a factor of for any . However, there exist several approximation algorithms that hold in any metric space [1, 2]. Gonzalez, for one, gave a greedy approach: Select the first center from arbitrarily, and while , repeatedly find the point in whose minimum distance to the chosen centers is maximized and add it to .
In many realworld applications, demands are not restricted to a discrete set but may be distributed throughout an area. Consider, for example, installing charging stations in a warehouse so that the worstcase travel time of robots to their nearest stations is minimal. In practice, regions of demand are often modelled using polygonal domains. A polygonal domain with holes and vertices is a connected region whose boundary comprises line segments that form simple closed polygonal chains. If is without holes, then it is a simple polygon. We define the geodesic distance between any two points to be the Euclidean length of the shortest path connecting and that is contained in .
Given a polygonal domain , the geodesic center problem on asks to find a set of points in that minimizes the maximum geodesic distance from any point in to its closest point in . We call the center of . Asano and Toussaint [3] gave the first algorithm for computing the center of a simple polygon with vertices; it runs in time. This result was later improved by Pollack et al. [4] to , and recently, Ahn et al. [5] presented an optimal lineartime algorithm. Following these explorations, Oh et al. [6] gave an time algorithm for computing the center of a simple polygon. However, it appears that no results are known for in the case of simple polygons. Likewise, for polygons with one or more holes, results are limited: only the center problem has been solved with a running time of [8].
In practice, facilities are often restricted to feasible locations. Hence, there has been some interest in constrained versions of the geodesic center problem on polygonal domains. Oh et al. [9] considered the problem of computing the center of a simple polygon constrained to a set of line segments or simple polygonal regions in the polygon. Du and Xu [7] proposed a 1.8841approximation algorithm for computing the center of a convex polygon with centers restricted to the boundary of .
In this paper, we consider a new variant of the geodesic
center problem that restricts facilities to the vertices of the given polygonal domain. Unlike the original problem and the constrained versions above, our problem is a combinatorial optimization problem: We draw centers from a finite set of points rather than a region in the plane. Viewing each vertex as a potential site to start a fire, we arrive at the following problem formulation we adopt in this paper.
Definition 1 (Polygon Burning)
Given a polygonal domain with holes and vertices and an integer , find a set of vertices of such that is consumed as quickly as possible when burned simultaneously and uniformly from .
Section 2 is devoted to the background required for our study. In Section 3, we prove that PB is NPhard when is part of the input. In Section 4, we show that the center of the vertices of under the geodesic metric on provides a approximation for PB on . This result leads to an time approximation algorithm for PB. Finally, given the NPhardness of PB in general, we shift our focus to restricted instances. In Section 5, we consider convex polygons that contain no Voronoi vertex from the Voronoi diagram of their vertices. We call such instances sliceable. Their structure admits a natural ordering of separable subproblems, permitting an exact algorithm using the dynamic programming technique.
2 Preliminaries
Unless stated otherwise, the distance metric we use on a polygonal domain is the geodesic metric on . The diameter of , , is the largest distance between any two points in .
Let be a set of points, called sites or burn sites, in a region . The Voronoi diagram of is the subdivision of into Voronoi regions, one per site , such that any point in the Voronoi region of is closer to (using the geodesic metric on ) than to any other site in . We refer to as .
Consider a polygonal domain with vertices . Let be a selection of burn sites. Each Voronoi region in the Voronoi diagram of is the set of points in burned by the fire from site . We associate with each point in the time it burns, which is the distance travelled by the fire from to . It follows that burns in time . As described in Definition 1, PB asks to find a set , , that minimizes . We let denote such an optimizing set and let be the minimum burning time of .
A geodesic disk of radius centered at a point is the set of points in at most geodesic distance from . By definition, the union of geodesic disks of radius centered at the sites in contains . Observe that since cannot be covered by geodesic disks of radius otherwise. The time to burn given any nonempty selection of burn sites is at most . Hence any nonempty selection of burn sites in gives a approximation for PB with sites on .
3 Hardness
In this section, we show that PB is NPhard on polygonal domains. We reduce from 4Planar Vertex Cover (4VPC): Given a planar graph with maxdegree four and an integer , does contain a vertex cover (i.e., a set of vertices such that every edge in contains at least one vertex in ) of size at most ? This problem is known to be NPhard [12].
Given an instance of 4PVC, we construct an equivalent instance of PB. First we compute an orthogonal drawing of with bends on an integer grid of area (Figure 1a) using an time algorithm due to Tomassia and Tollis [14]. Every edge is represented as a sequence of connected line segments in , denoted , where and correspond to the endpoints of and are bends in . The length of is the sum of the lengths of its line segments.
Next we transform into a constrained straightline drawing of a subdivision of in two steps. First we add a vertex at every bend in (Figure 1b). Then we replace each segment () along with either or equallength edges depending on the parity required to ensure that the overall number of segments along
is odd (Figure
1c). Property 1 and 2 follow from these steps. Property 2 is due to the fact that a double subdivision of an edge in increases the size of any vertex cover of by one.Property 1
For every , .
Property 2
has a vertex cover of size if and only if has a vertex cover of size .
Finally, we convert into a polygonal domain by thickening each line segment in as follows. For every vertex , we replace with a set of four vertices at , , , and , where is a fixed constant. Let denote the convex hull of . We define to be the union of the collection of regions for all .
It is straightforward to verify that the above transformation of an instance of 4PVC to an instance of PB runs in time. Furthermore, has vertices, and the number of bits required in the binary representation of each vertex coordinate is bounded by a polynomial in . It remains to demonstrate that:
Lemma 1
has a vertex cover of size at most if and only if can be burned in time using sites.
Proof
It suffices to show that for any , can be burned in time if and only if at least one vertex in is a burn site. The forward direction follows from observing that is a loose upper bound on the burning time of given that a site is located in either or (Property 1). For the reverse direction, suppose no vertices in or are selected. We obtain a lower bound on the burning time of by considering the scenario where is burned the quickest: First, for each vertex adjacent to either or , let every vertex in be a burn site. Second, assume and have as many adjacent edges as possible in to assist in burning . At most one of these two adjacent vertices can have degree greater than two since at most one is on the integer grid, and this vertex, say , can have degree at most four. The other vertex can have degree two, but its adjacent edges must be colinear in the drawing. Finally, suppose all these edges are as short as possible in the drawing ( by Property 1). We find that the burning time of , if no vertex in or is a site, is bounded below by (see Figure 2). The lemma then follows from Property 2.
As a result, we obtain:
Theorem 3.1
PB is NPhard on polygonal domains.
4 Approximation by a Center
We present a straightforward approximation algorithm for PB by considering the center problem described in the introduction.
Theorem 4.1
The radius of a center of the vertices of , using the geodesic metric on , provides a approximation of .
Proof
Let denote a center of and let denote its radius. Observe two facts: First, since . Second, each point is within of a vertex of , and is at most from some center in . Therefore, by the triangle inequality, as desired.
Corollary 1
Applying Gonzalez’s greedy approximation algorithm for finding a center of yields an time approximation algorithm for PB on that uses space.
Proof
The approximation algorithm provides an approximate center of whose radius is at most where , as in the above proof, is the optimal center radius. Following that proof, this yields a approximation. The time and space complexity are due to performing geodesic distance queries on using an algorithm by Guo et al. [10]. Note, if is simple, then a approximation for PB can be found in time using space by the faster geodesic distance queries of Guibas and Hershberger [11].
5 Sliceable Polygons
Definition 2
A sliceable polygon is convex and contains no Voronoi vertex from the Voronoi diagram of its vertices .
Every Voronoi edge in that intersects slices through (Figure 3). We can solve PB on using dynamic programming, as admits a total ordering of vertices with the property that if are burn sites, then the region of burned by does not share a boundary with the region of burned by (Lemma 2). We start with a simple example that indicates the use of this property.
5.1 Polygons in One Dimension
Let be a dimensional polygon with vertices ordered by xcoordinate. Let be the segment of from to . The minimum time to burn using sites is
where is the time to burn from site and denotes the minimum time to burn using sites in addition to . If , then is achieved by choosing the next site () to minimize the larger of two values: (i) the time to burn between and and (ii) the minimum time to burn knowing is a burn site with burn sites remaining. If , no sites are allowed beyond , in which case the minimum time to burn , with a burn site, is .
This recurrence relation relies only on the property that any burn site preceding the burn site is farther from every point in than for . We will prove a similar property for sliceable polygons.
A dynamic programming algorithm follows directly from the recurrence.
Theorem 5.1
PB can be solved in time on a dimension polygon with vertices.
Proof
(Sketch) Use dynamic programming. Two observations hold on each iteration of the algorithm: (i) The choice of the following site is unaffected by the sites selected before the current site , and (ii) we evaluate every possible choice and take the best amongst them. The natural ordering of subproblems implied by (i) combined with the virtue of an exhaustive search as noted in (ii) allows us to successfully compute the solution to the original problem from the solutions to the recursive subproblems.
The algorithm populates a table of size . To fill each entry, it computes the minimum of previous entries. Therefore, the total running time is .
5.2 Ordering
Lemma 2
The vertices of a sliceable polygon can be ordered such that for any burn sites , the region of burned from does not share a boundary with the region in burned from .
Proof
We first prove that (P1) each Voronoi region in shares a boundary with at most two other Voronoi regions. Then we show that (P2) the graph joining two vertices if they share such a boundary is connected and thus forms a path, which defines an ordering of vertices required by the lemma. (The path can be directed in two ways, either of which defines such an ordering.)
For (P1), suppose for the sake of contradiction that vertex of forms Voronoi edges in that cross with three other vertices, say , , and . Since is sliceable, the endpoints (Voronoi vertices) of these Voronoi edges lie outside .
Let be the convex hull of . The Voronoi edge between and in contains the corresponding Voronoi edge in since every point that is closest to and among all vertices of is still closest to and among a subset of . The same is true for the Voronoi edges between and and between and . Thus, since all three of these Voronoi edges cross in the corresponding edges in cross and hence cross as well. It follows that a sliceable polygon with a vertex that creates Voronoi edges crossing with three different vertices , , and implies the existence of a sliceable quadrilateral with the same property. To obtain a contradiction and establish (P1), we will argue that no such quadrilateral exists.
Assume , , and are labelled so that the circumcentres of and of are the two Voronoi vertices shared by these three Voronoi edges. Since the boundary of the Voronoi region of intersects in three segments that do not contain or , lies on the side of the line through opposite and lies on the side of the line through opposite of . It follows that and are obtuse. Thus the interior angle of at is greater than , contradicting the convexity of (Figure 4). This result establishes (P1).
For (P2), assume for a contradiction that the graph has more than one connected component. Then no intercomponent vertices form Voronoi boundaries with each other in . It follows that the fires burning from separate connected components never meet, and hence cannot be burned entirely. This contradiction establishes (P2).
5.3 Sliceability of Subsets
In this section, we study the sliceability of subsets of sliceable polygons. In particular, we show that a sliceable polygon contains no Voronoi vertex from for any subset . While the existence of a dynamic programming algorithm does not require this result, it adds to our characterization of sliceable polygons and allows us to define a simpler recurrence for PB on which yields a faster dynamic programming algorithm.
The Delaunay triangulation of a set of sites, denoted , is the dual graph of . It is a triangulation of such that no circumcircle of any triangle in contains a site. The circumcenters of the triangles are the vertices of .
Lemma 3
Let be a triangulation of a convex polygon . Suppose there exist adjacent triangles and in that form a convex quadrilateral. If contains the circumcenter of and is interior to the circumcircle of , then contains the circumcenter of or the circumcenter of , or both.
Proof
Assume the vertices of quadrilateral are labelled in counterclockwise order. By the conditions of the lemma, triangles and form the Delaunay triangulation of quadrilateral . Orient so that is aligned with the xaxis with and lying above it (Figure 5). Let , , and denote the circumcenters of , , and , respectively. Since lies outside above , lies below , implying that is below . Similarly, since lies outside left of , lies right of , which implies that is right of . To prove that either or lies in given that is in , consider two cases:
Case 1: Suppose lies on or left of . Let be the midpoint of . Since is right of and both and lie on the bisector of and , lies along . Hence, by the convexity of , lies in .
Case 2: Otherwise, lies right of . Then . We show that must lie on or above in this scenario. Assume for a contradiction that lies below . Then . This yields , which implies that is not convex. This contradiction establishes that lies above . By the same analysis provided in the previous case, we conclude that contains .
Lemma 4
Consider a triangulation of a convex polygon . If contains the circumcenter of a triangle in , then it contains the circumcenter of a triangle in the Delaunay triangulation of .
Proof
Let be an edge in incident to two triangles and that form a convex quadrilateral. We say is an illegal edge if lies in . A new triangulation of can be obtained from by replacing with . This edge flip operation creates and in place of and . If is illegal, then, by Lemma 3, contains the circumcenter of or (or both) if it contains the circumcenter of or . More generally, assuming that is obtained by flipping an illegal edge in , contains the circumcenter of some triangle in if it contains the circumcenter of some triangle in . We can compute by flipping illegal edges in until none exist [13]. Therefore, by repeated application of Lemma 3, contains the circumcenter of some triangle in if it contains the circumcenter of some triangle in .
Theorem 5.2
If a convex polygon does not contain the circumcenter of any triangle in , then does not contain the circumcenter of any triangle in for any .
Proof
For completeness, we restate the theorem in terms of Voronoi diagrams. If a convex polygon does not contain any Voronoi vertex of , then does not contain any Voronoi vertex of for any .
We provide a contrapositive proof. Suppose contains the circumcenter of in . Let be any triangulation of containing . Of course, contains the circumcenter of a triangle in , implying that contains the circumcenter of a triangle in by Lemma 4.
Corollary 2
If is sliceable, then the convex hull of is sliceable for any .
Proof
Since contains no Voronoi vertex of for any by Theorem 5.2, neither does any subset of , including the convex hull of .
5.4 Dynamic Programming Algorithm
Let be a sliceable polygon. The ordering of its vertices as defined in Lemma 2 permits a dynamic programming algorithm similar to the one used for dimensional polygons that solves PB on .
Let denote the minimum time to burn the subset of from the bisector of onward given that is a burn site and sites remain to be chosen.
where and represent the intersections of the bisector of with . It follows that the minimum time to burn using sites is
Theorem 5.3
Using a dynamic programming algorithm, PB can be solved in time on a vertex sliceable polygon.
Proof
(Sketch) We prove that the recurrence for is correct by showing that the maximum distance from burn site to a point in the region that is burnt by is correctly calculated in . Let be the burn site preceding , and be the burn site following in the vertex ordering. The region is bounded by the perpendicular bisectors of segments and which intersect in segments and respectively (Figure 6). It suffices to show that the time to burn from is the larger of , considered in , and , considered in . If no site precedes then the recurrence correctly uses instead of . Likewise, if no site follows then the recurrence correctly uses instead of .
Suppose for the sake of contradiction that there exists a vertex of in such that the circle centered at through contains .
First, is acute since for to lie inside , both edges of incident to must form acute angles with its radius . Hence, since is convex, both the edge and the edge form an acute angle with . Second, both and lie outside the circle with diameter , otherwise would be closer to or than to and hence not be burned by . This implies that is acute. Finally, (i) if in the vertex ordering then is acute, otherwise the perpendicular bisector of would not separate from which violates the properties of the ordering. Similarly, (ii) if then is acute.
Combining these three observations, we have in case (i) that is acute and in case (ii) that is acute, both of which contradict Corollary 2.
6 Conclusion
In this paper, we proved PB to be NPhard on general polygonal domains. Nevertheless, the hardness for simple and convex polygons remains open. In addition, we gave an time approximation algorithm for PB. Finally, we considered sliceable polygons on which we can obtain a dynamic programming solution for PB. Avenues for future research are to improve the approximation algorithm, to expand the class of polygons solvable using dynamic programming, and to resolve the complexity of PB on simple polygons.
References
 [1] Gonzalez, T.: Clustering to minimize the maximum intercluster distance. Theoretical Computer Science 38, 293–306 (1985)

[2]
Hochbaum, D., Shmoys, D.: A Best Possible Heuristic for the
Center Problem. Mathematics of Operations Research 10(2), 180–184 (1985)  [3] Asano, T., Toussaint, G.: Computing the Geodesic Center of a Simple Polygon. In: Johnson, D., Toussaint, G. (eds.) Discrete Algorithms and Complexity, pp. 65–79 (1987). 10.1016/B9780123868701.500101
 [4] Pollack, R., Sharir, M., Rote, G.: Computing the geodesic center of a simple polygon. Discrete Computational Geometry 4, 611–626 (1989)
 [5] Ahn, H., Luis, B., Bose, P., De Carufel, J., Korman, M., Oh, E.: A lineartime algorithm for the geodesic center of a simple polygon. Discrete & Computational Geometry, 56(4), 836–859 (2016)
 [6] Oh, E., De Carufel, J., Ahn, H.: The geodesic 2center problem in a simple polygon. Computational Geometry, 74, 21–37 (2018)
 [7] Du, H., Xu Y.: An approximation algorithm for kcenter problem on a convex polygon. Journal of Combinatorial Optimization 27(3):504–518 (2014)
 [8] Wang. H.: On the Geodesic Centers of Polygonal Domains. In: Sankowski, P., Zaroliagis, C. (eds.) ESA 2016, LIPIcs, vol. 57, pp 77:1–77:17, Schloss Dagstuhl–LeibnizZentrum fuer Informatik, Dagstuhl (2016). 10.4230/LIPIcs.ESA.2016.77
 [9] Oh, E., Son, W., Ahn., H.: Constrained Geodesic Centers of a Simple Polygon. In: Pagh, R. (ed.) SWAT 2016, LIPIcs, vol. 53, pp. 29:1–29:13. Schloss Dagstuhl–LeibnizZentrum fuer Informatik, Dagstuhl (2015). 10.4230/LIPIcs.SWAT.2016.29
 [10] Guo, H., Maheshwari, A., Sack, J.: Shortest Path Queries in Polygonal Domains. In: Fleischer, R., Xu, J. (eds.) AAIM 2008, LNCS, vol. 5034, pp. 200–211. Springer, Heidelberg (2008). 10.1007/9783540688808_20
 [11] Guibas, J., Hershberger, J.: Optimal shortest path queries in a simple polygon. Journal of Computer and System Sciences 39(2), 126–152 (1989)
 [12] Garey, M., Johnson, D.: Computers and Intractability: A Guide to the Theory of NPCompleteness. W. H. Freeman & Co., New York (1979)
 [13] Berg, M., Cheong, O., van Kreveld, M., Overmars, M.: Computational Geometry Algorithms and Applications. 3rd edn. Springer, Heidelberg (2008)
 [14] Tamassia, R., Tollis, I.: Planar grid embedding in linear time. IEEE Transactions on Circuits and Systems 36(9), 1230–1234, Sept (1989)
Comments
There are no comments yet.